///////////////////////////////////////////////////////////////////////////////
// advancedskills.h
///////////////////////////////////////////////////////////////////////////////
// Klasse fuer erweiterte Faehigkeiten
///////////////////////////////////////////////////////////////////////////////

#ifndef _ADVANCEDSKILLS_H_
#define _ADVANCEDSKILLS_H_
	
#if __GNUG__ >= 2
#  pragma interface
#endif

#include <stream.h>
// Jan
#include <assert.h>
// Jan
#include "weltmod.h"
#include "sender.h"
#include "positions.h"

// Regions
#define REGION_I                   1
#define REGION_II                  2
#define REGION_III                 3
#define REGION_IV                  4
#define REGION_V                   5
#define REGION_VI                  6
#define REGION_VII                 7
#define REGION_VIII                8
#define REGION_IX                  9
#define REGION_X                  10

// Konstanten fuer ComputeRegion
#define AREA_U_1               -28.0
#define AREA_U_2               -20.0
#define AREA_O_1                28.0
#define AREA_O_2                20.0

#define GOAL_WIDTH              14.02

// Jan
#define PLAYER_RADIUS 0.8
#define BALL_RADIUS 0.085
#define CONTROL_RADIUS 1.0
#define KICK_RANGE (PLAYER_RADIUS + BALL_RADIUS + CONTROL_RADIUS)
#define NEAR_BALL_RANGE (PLAYER_RADIUS + BALL_RADIUS + CONTROL_RADIUS/2)

#define SIDE_LEFT 1
#define SIDE_RIGHT -1

#define KICK_POWER_RATE 0.013
#define DASH_POWER_RATE 0.01
#define MAX_POWER 100.0
#define MAX_BALL_ACC (KICK_POWER_RATE * MAX_POWER)

#define STAMINA_INC 20

#define HALF_LENGTH 52.5
#define HALF_WIDTH 34.0

#define FLOAT_ERROR 0.0001

static struct Vektor NULL_VEKTOR = {DBL_MAX, DBL_MAX};

#define NULL_POINT (NULL_VEKTOR)

// Jan

class AdvancedSkills
{
private:    
  Weltmodell* myworld;
  Sender* mysender;

  Spieler_Selbst sim_ich;
  Ball sim_ball;
  
  float stamina, ziel_winkel, max_power, staerke, v_ball;
  Relative_Koordinate ball_pos, ball_pos_next;

  void getinformation();
  void setinformation(int k, float a, float b=0);
  int ausweichen(Winkel &gamma);
// Jan
  Vektor computeKickDir(const Geschwindigkeit targetSpeed);
  Vektor computeIntermediateTarget(const Geschwindigkeit targetSpeed);
  Koerper distanceBetween(Ball ball, Spieler player);
  int collides(Ball ball, Spieler player);
  void kick(Geschwindigkeit kickDir, int stat=IGNORE);
  void setKick(Geschwindigkeit kickDir);
  void testAssertion(Geschwindigkeit kickDir);
  int computeDash(Punkt myPos, Punkt ballPos, Winkel viewAngle, int simulateTicks);
// Jan

public:
  AdvancedSkills(Weltmodell* world, Sender* sender);
  ~AdvancedSkills();

  void SimpleChangeView(int width, int quality, int stat=IGNORE);
  void SimpleMoveTo(double x, double y, int stat=IGNORE);
  int SimpleTurn(double angle, int stat=IGNORE); // gibt die Zahl der Kommandos zurueck
  void SimpleDash(double power, int stat=IGNORE);
  int SimpleDashTurn(int power1, int power2, double angle, int stat=IGNORE);
  void SimpleKick(double power, double angle, int stat=IGNORE);
  void SimpleSay(char *message, int stat=IGNORE);
 
  void Dribbeln(Winkel zielrichtung);

  void GotoBall();
  void GotoInterceptPosition (Punkt ziel);
  void GotoPosition (Punkt ziel, int stat=IGNORE);
  int BestWay2Ball(const Ball ziel, const Spieler_Selbst ich, double *turn, double *last_dash, double *stamina_used);
// Jan
  void KickInDir(const Geschwindigkeit targetSpeed, int state=LAST, int maxKicks=3);  
  void Kick(const Koerper degree, const Koerper power, int state=LAST, int maxKicks=3);
  Winkel ComputeTurnAngle(Punkt point, Punkt myPos = NULL_POINT);
  Vektor ComputeBestWatchDirection (Punkt point);
  void FetchNearBall();
// Jan

  // Markus
  void ShareInfos (int stat=IGNORE);
  void CollectInfos (int stat=IGNORE);
  int ComputeRegion (Punkt pos_self);
  // errechnet aus der angegebenen Position eine Regionszugehoerigkeit
  // Markus
};

#endif
