/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////  baseskills.h - Klasse zur Kapselung der grundlegenden Spielerkommandos

#ifndef _BASESKILLS_H_
#define _BASESKILLS_H_

#if __GNUG__ >= 2
#  pragma interface
#endif

#include "comm.h"

//  Enter/Reenter-Rueckgabewerte
#define ENTER_ERROR -1
#define REENTER_ERROR -1
#define ENTER_SUCCESS 1
#define REENTER_SUCCESS 1
#define LEAVE_ERROR -1
#define LEAVE_SUCCESS 1

//  Kommando-Rueckgabewerte
#define VALUE_OUT_OF_RANGE -1
#define NOT_ENTERED -2
#define COMMAND_ERROR -3
#define COMMAND_SUCCESS 1

//  ChangeView-Flags
#define VIEW_WIDTH_NARROW 1
#define VIEW_WIDTH_NORMAL 2
#define VIEW_WIDTH_WIDE 3
#define VIEW_QUAL_HIGH 1
#define VIEW_QUAL_LOW 2

class BaseSkills
{
public:
	BaseSkills (Comm* communication);
	~BaseSkills ();

	int EnterField (char* teamname);
	int ReEnterField (char* teamname, int playernumber);
	int LeaveField ();

	char GetSide ();
	char* GetPlaymode ();
	int GetPlayerNumber ();
	
	int MoveTo (float x, float y);
	int Turn (float angle);
	int Dash (float power);
	int Kick (float power, float angle);
	int Say (char* message);
	int ChangeView (int width, int quality);
	
private:
	Comm* m_pcComm;
	int m_bEntered;
	
	char m_sSide;
	int m_nPlayerNumber;
	char m_sPlaymode [40];
	char m_sTeamName [20];
};

#endif
