#include "entscheidung.h"
#include "referee.h"
#include "special_positions.h"
#include <math.h>
#include <stdlib.h>

Brain::Brain (Sensorik* sensorik, Sensors* sense, Sender* sender, Weltmodell* weltmodell, AdvancedSkills* advskills)
{
  m_nState = STATE_INIT;

// Jan
  interceptPos = NULL_POS;
  lookNewTime = 0;
  wantedPosReached = 0;

  stepsOurPlayer[PLAYER_UNKNOWN] = MAX_STEPS;   // Initialisierung;
  stepsTheirPlayer[PLAYER_UNKNOWN] = MAX_STEPS; // Initialisierung;
  
// Jan
  
  m_nNextLeftDirection = DIRECTION_FRONT;
  m_nNextRightDirection = DIRECTION_FRONT;
  m_nKickCounter = 0;

  m_cSensorik = sensorik;
  m_cSense = sense;
  m_cSender = sender;
  m_cWeltmodell = weltmodell;
  m_cAdvSkills = advskills;
}

void Brain::InitRole ()
{
  // fuer die Cebit (Parameter sind schon gesetzt)
  m_fWatchDerivation = m_cWeltmodell->frage_param (0);
  m_fDribbleFactor = m_cWeltmodell->frage_param (1);
  m_fAcceptance = m_cWeltmodell->frage_param (2);
  m_fBestFactor = m_cWeltmodell->frage_param (3);
  m_fMeanFactor = m_cWeltmodell->frage_param (4);
  m_fKickPower = m_cWeltmodell->frage_param (5);
  /*

#ifdef DEBUG
  cout << "Rolle " << m_cWeltmodell->frage_rolle () << endl;
#endif
  switch (m_cWeltmodell->frage_rolle ())
  {
    case ROLLE_TORWART:
      m_fWatchDerivation = 80.0;
      m_fDribbleFactor = 0.1;
      m_fAcceptance = 3.0;
      m_fBestFactor = 0.8;
      m_fMeanFactor = 0.2;
      m_fKickPower = 300.0;
      break;
    case ROLLE_LIBERO:
      m_fWatchDerivation = 50.0;
      m_fDribbleFactor = 0.6;
      m_fAcceptance = 3.0;
      m_fBestFactor = 0.7;
      m_fMeanFactor = 0.3;
      m_fKickPower = 300.0;
      break;
    case ROLLE_LINKER_VERTEIDIGER:
    case ROLLE_RECHTER_VERTEIDIGER:
    case ROLLE_VERTEIDIGER:
      m_fWatchDerivation = 40.0;
      m_fDribbleFactor = 0.3;
      m_fAcceptance = 2.0;
      m_fBestFactor = 0.6;
      m_fMeanFactor = 0.4;
      m_fKickPower = 300.0;
      break;
    case ROLLE_LINKES_MITTELFELD:
    case ROLLE_RECHTES_MITTELFELD:
    case ROLLE_DEFENSIV_MITTELFELD:
      m_fWatchDerivation = 30.0;
      m_fDribbleFactor = 0.5;
      m_fAcceptance = 2.0;
      m_fBestFactor = 0.3;
      m_fMeanFactor = 0.7;
      m_fKickPower = 300.0;
      break;
    case ROLLE_LINKS_AUSSEN:
    case ROLLE_RECHTS_AUSSEN:
      m_fWatchDerivation = 30.0;
      m_fDribbleFactor = 0.5;
      m_fAcceptance = 2.0;
      m_fBestFactor = 0.4;
      m_fMeanFactor = 0.6;
      m_fKickPower = 300.0;
      break;
    case ROLLE_SPIELMACHER:
    case ROLLE_LINKER_STUERMER:
    case ROLLE_RECHTER_STUERMER:
    case ROLLE_MITTEL_STUERMER:
      m_fWatchDerivation = 30.0;
      m_fDribbleFactor = 0.5;
      m_fAcceptance = 3.0;
      m_fBestFactor = 0.4;
      m_fMeanFactor = 0.6;
      m_fKickPower = 300.0;
      break;
  } */
}

Brain::~Brain ()
{
}

void Brain::Think ()
{
// Jan

Ball ball;
Spieler_Selbst self;
Punkt ballPos;
Punkt selfPos;
Koerper distanceToBall;
Zeit time;

Winkel turnAngle;

// Jan

Punkt pos_at_ball;
Punkt ball_pos, neueStammpos;
Relative_Koordinate rel_ball_pos;
Punkt goal_pos;
Relative_Koordinate rel_goal_pos;

Koerper best_kick_degree, next_watch_degree, best_power; // relative Angaben
Vektor global_best_kick_direction; // absolute Angabe
double best_kick_value, global_best_kick_value;

  m_cWeltmodell->entscheidung_getroffen ();
  while (1)
  {
    while (m_cWeltmodell->neue_entscheidung() == NICHTS_NEUES) 
      pause (); // solange nichts neues - nichts machen

#ifdef DEBUG
    ball = m_cWeltmodell->frage_ball();
    self = m_cWeltmodell->frage_selbst();
    cout << "Spielzustand: " << m_cWeltmodell->frage_spielzustand () << endl;
    cout << "MyPos:     x: " << self.frage_p().x1 << " y: " << self.frage_p().x2 << endl;
    cout << "MySpeed:   x: " << self.frage_v().x1 << " y: " << self.frage_v().x2 << endl;
    cout << "MySpeed-Norm: " << self.frage_v ().norm () << endl;
    cout << "ViewAngle: " << rad_in_deg(self.frage_richtung().arg()) << endl;
    cout << "BallPos:   x: " << ball.frage_p().x1 << " y: " << ball.frage_p().x2 << endl;
    cout << "BallSpeed: x: " << ball.frage_v().x1 << " y: " << ball.frage_v().x2 << endl;
#endif

    // Stammpos in Abhaengigkeit von der Abseitslinie umsetzen
    neueStammpos=(InplayPositions [m_cWeltmodell->frage_aufstellung ()][m_cWeltmodell->frage_nummer()]).position;
    if( -neueStammpos.x1 < m_cWeltmodell->frage_aktuelle_situation()->offsideLineX() ){
      neueStammpos.x1=-(m_cWeltmodell->frage_aktuelle_situation()->offsideLineX()-3.5);
      m_cWeltmodell->setze_stammpos_spiel(neueStammpos);
    }
    else{
      m_cWeltmodell->setze_stammpos_spiel(neueStammpos);
    }
    switch (m_cWeltmodell->frage_spielzustand ())
    {
      case PLAY_ON:
      case KICK_OFF:
        if (m_cWeltmodell->frage_spielzustand () == KICK_OFF && m_cWeltmodell->frage_initiative () == INITIATIVE_SIE)
          break;
        ball = m_cWeltmodell->frage_ball();
        self = m_cWeltmodell->frage_selbst();
        ballPos = ball.frage_p();
        selfPos = self.frage_p();
        distanceToBall = (ballPos-selfPos).norm();
        time = self.frage_jetzt();
	
        if(ball.ist_unsicher() || distanceToBall >= KICK_RANGE) 
        {
          m_nNextLeftDirection = DIRECTION_FRONT;
          m_nNextRightDirection = DIRECTION_FRONT;
          global_best_kick_value = WORST_DISTANCE;
          m_nKickCounter = 0;

          /* 
           * Possible States are:
           *                      STATE_FETCH_BALL
           *                      STATE_TAKE_INFLUENCE_POS
           *                      STATE_TAKE_REGULAR_POS
           *                      STATE_SEEK_BALL
           *                      STATE_TURN_TO_BALL
           *                      STATE_UNKNOWN
           */
     
          // mit Hilfe des alten Status (m_nState), einen temporaeren Status bestimmen,;
          // der dann angibt, was zu tun ist.;
    
          int tempState;

          if(ball.frage_wert() < 3) tempState = STATE_UNKNOWN;  // ich sehe den Ball -> neu entscheiden;

          else {
            switch(m_nState) {
	    case STATE_FETCH_BALL:
	    case STATE_TAKE_INFLUENCE_POS:
	    case STATE_TAKE_REGULAR_POS:
	      if(isNear(selfPos, interceptPos) || time >= lookNewTime) {
		tempState = STATE_UNKNOWN;
	      }
	      else tempState = m_nState;
	      break;
	    case STATE_LOOK_FOR_BALL:
	      tempState = STATE_SEEK_BALL;
	      break;
	    case STATE_SEEK_BALL:
	      tempState = m_nState;
	      break;
	    case STATE_FETCH_NEAR_BALL:
	    case STATE_TURN_TO_BALL:
	    case STATE_UNKNOWN:
	      tempState = STATE_UNKNOWN;
	      break;
	    default:
	      tempState = STATE_UNKNOWN;
	      break;
            } 
          }
	  
          // nun tun was zu tun ist, bei STATE_UNKNOWN neuen Status berechnen, sonst;
          // als aktuellen Status den von tempState nehmen;
	  
          if(tempState == STATE_UNKNOWN) tempState = decideNew();
	  
	  

          switch(tempState) {
	  case STATE_FETCH_BALL:
	    m_nState = tempState;
	    m_cSender->InitializeQueue();
	    m_cAdvSkills->GotoPosition(interceptPos); 
	    wantedPosReached = 0;
	    break;
	  case STATE_FETCH_NEAR_BALL:
	    m_nState = tempState;
	    m_cSender->InitializeQueue();
	    m_cAdvSkills->GotoPosition(interceptPos, LAST); 
	    wantedPosReached = 0;
	    break;
//	  case STATE_FETCH_NEAR_BALL:
//            m_nState = tempState;
//            m_cSender->InitializeQueue();
//            m_cAdvSkills->FetchNearBall();
//            wantedPosReached = 0;
//            break;
	  case STATE_TAKE_INFLUENCE_POS:
	  case STATE_TAKE_REGULAR_POS:
	    m_nState = tempState;
	    m_cSender->InitializeQueue();
	    if(!wantedPosReached) {
	      m_cAdvSkills->GotoInterceptPosition(interceptPos);
	      if(isNear(selfPos, interceptPos)) 
		wantedPosReached = 1;
	    }
	    break;
	  case STATE_LOOK_FOR_BALL:
	    m_nState = tempState;
	    turnAngle = m_cAdvSkills->ComputeTurnAngle(ballPos);
	    m_cSender->InitializeQueue();
	    m_cAdvSkills->SimpleTurn(turnAngle, IGNORE);
	    break;
	  case STATE_SEEK_BALL:
	    m_nState = tempState;
	    m_cSender->InitializeQueue();
	    m_cAdvSkills->SimpleTurn(80.0, IGNORE);
	    break;
	  case STATE_TURN_TO_BALL:
	    m_nState = tempState;
	    turnAngle = m_cAdvSkills->ComputeTurnAngle(ballPos);
	    m_cSender->InitializeQueue();
	    m_cAdvSkills->SimpleTurn(turnAngle, IGNORE);
	    break;
	  default:
	    cout << "!!!!!!!!!! MISTAKE !!!!!!!!!!" << endl;
	    cout << "This decision is not possible here." << endl;
	    assert(0);
          }
	  // extra Behandlung fuer den Torwart;
	  if(tempState == STATE_SEEK_BALL || tempState == STATE_TURN_TO_BALL || tempState == STATE_LOOK_FOR_BALL) {
	    if(m_cWeltmodell->frage_rolle() == ROLLE_TORWART) {
	      if(distanceToBall <= GOALIE_CLEAR_RANGE) {
		Tor goal = m_cWeltmodell->frage_ihr_tor();
		Winkel shotAngle = m_cAdvSkills->ComputeTurnAngle(goal.p);
		m_cAdvSkills->SimpleKick(MAX_POWER, shotAngle);
		m_cAdvSkills->SimpleKick(MAX_POWER, shotAngle);
	      }
	    }
	  }
	  
          // Bildschirmausschrift welchen Zustand ich erreicht habe;
#ifdef DEBUG
          cout << "Decision: ";
          switch(m_nState) {
            case STATE_FETCH_BALL:
              cout << "STATE_FETCH_BALL";
              cout << "   InterceptPosition: x: " << interceptPos.x1 << " y: " << interceptPos.x2;
              cout << "   UpToTime: " << lookNewTime; 
              break;
          case STATE_FETCH_NEAR_BALL:
            cout << "STATE_FETCH_NEAR_BALL";
            cout << "   UpToTime: " << lookNewTime; 
            break;
            case STATE_TAKE_INFLUENCE_POS:
              cout << "STATE_TAKE_INFLUENCE_POS";
              cout << "   InterceptPosition: x: " << interceptPos.x1 << " y: " << interceptPos.x2;
              cout << "   UpToTime: " << lookNewTime; 
              break;
            case STATE_TAKE_REGULAR_POS:
              cout << "STATE_TAKE_REGULAR_POS";
              cout << "   InterceptPosition: x: " << interceptPos.x1 << " y: " << interceptPos.x2;
              cout << "   UpToTime: " << lookNewTime; 
              break;
            case STATE_SEEK_BALL:
              cout << "STATE_SEEK_BALL";
              break;
	    case STATE_LOOK_FOR_BALL:
	      cout << "STATE_LOOK_FOR_BALL";
	      cout << "   TurnAngle: " << turnAngle;
              break;
            case STATE_TURN_TO_BALL:
              cout << "STATE_TURN_TO_BALL";
	      cout << "   TurnAngle: " << turnAngle;
              break;
            default:
              cout << "!!!!!!!!!! MISTAKE !!!!!!!!!!";
              assert(0);
              break;  
          }
          cout << endl << endl;
#endif
        }

#ifdef JAN_TEST
// Jan;
	else {
	  double angle;
	  int passPlayer = -1;
	  Vektor point;
	  int i;

	  point.x1 = 52.5;
	  point.x2 = 0;
	  
	  Tor goal = m_cWeltmodell->frage_ihr_tor ();
	  point = goal.p;

	  angle = m_cAdvSkills->ComputeTurnAngle(point);
	  
	  m_cSender->InitializeQueue();
	  m_nState = STATE_KICK_BALL;
	  m_cAdvSkills->Kick(angle, 300);
	}
// Jan;	
#endif

#ifndef JAN_TEST

        else
        {
          m_nRegion = m_cAdvSkills->ComputeRegion (selfPos);
#ifdef DEBUG
          cout << "   Linker Scanwert: " << m_nNextLeftDirection << endl;
          cout << "   Rechter Scanwert: " << m_nNextRightDirection << endl;
          cout << "   State: " << m_nState << endl;
#endif
          if (m_nState != STATE_SCAN_KICK_DIRECTION)
            if (!ComputeNextWatchDirection (&next_watch_degree)) // keine sinnvolle Blickrichtung mehr
            {
              // Alternativ: Torschuss
              m_nState = STATE_DRIBBLE_BALL;

            Punkt pos_dir;
            Relative_Koordinate rel_pos_dir;
              pos_dir.x1 = selfPos.x1 + global_best_kick_direction.x1;
              pos_dir.x2 = selfPos.x2 + global_best_kick_direction.x2;
              m_cWeltmodell->berechne_relativ (rel_pos_dir, pos_dir);
              best_kick_degree = rad_in_deg (rel_pos_dir.richtung); 

              m_cSender->InitializeQueue ();
              m_cAdvSkills->Dribbeln (best_kick_degree);
              m_nNextLeftDirection = DIRECTION_FRONT;
              m_nNextRightDirection = DIRECTION_FRONT;
              global_best_kick_value = WORST_DISTANCE;
              m_cWeltmodell->entscheidung_getroffen ();
              continue;
            }
#ifdef DEBUG
          cout << "next_watch_degree: " << next_watch_degree << endl;
          cout << "m_fWatchDerivation: " << m_fWatchDerivation << endl;
#endif
          if (fabs (next_watch_degree) >= m_fWatchDerivation)
          {
            /*m_nState = STATE_SCAN_KICK_DIRECTION;
            m_cSender->InitializeQueue ();
            if (m_nNextLeftDirection == DIRECTION_FRONT - 1 && m_nNextRightDirection == DIRECTION_FRONT + 1)
            {
              //m_cAdvSkills->Kick (-next_watch_degree, 1.0, IGNORE, 2);
              // eigene Geschwindigkeit simulieren und an SimpleTurn uebergeben
              m_cAdvSkills->SimpleTurn (-next_watch_degree, IGNORE);
            }
            else
            {
              m_cAdvSkills->SimpleTurn (-next_watch_degree, IGNORE);
            }
            // eventuell: m_cAdvSkills->ShareInfos ();
            next_watch_degree = 0.0;*/
#ifdef DEBUG
            cout << "Ich will auf das Tor schiessen!" << endl;
#endif
            // fehlt: Bestimmung, ob Torrichtung frei, sonst drehen
            m_nState = STATE_KICK_BALL;
            m_cSender->InitializeQueue ();
            goal_pos = m_cWeltmodell->frage_ihr_tor ().p;
            if (selfPos.x2 >= 0)
              goal_pos.x2 += GOAL_WIDTH/2.0 - 4.0;
            else
              goal_pos.x2 -= GOAL_WIDTH/2.0 - 4.0;
            m_cWeltmodell->berechne_relativ (rel_goal_pos, goal_pos);
            m_cAdvSkills->Kick (-(rad_in_deg (rel_goal_pos.richtung) + m_nKickCounter * 5.0), GOAL_KICK_POWER, IGNORE);
            m_nNextLeftDirection = DIRECTION_FRONT;
            m_nNextRightDirection = DIRECTION_FRONT;
            global_best_kick_value = WORST_DISTANCE;
            m_nKickCounter++;
            break;
          }
          else
          {
            best_kick_value = ComputeBestKickDirection (&best_kick_degree, &best_power);
            if (best_kick_value < global_best_kick_value)
            {
              global_best_kick_value = best_kick_value;
              global_best_kick_direction.setzen (deg_in_rad (best_kick_degree) + self.frage_richtung ().arg (), best_power * KICK_POWER_RATE);
            }
            switch (ComputeBestActiveBehaviour (best_kick_value))
            {
              case DO_KICK:
	      case DO_GOALKICK:
#ifdef DEBUG
                cout << "Ich will schiessen!" << endl;
                cerr << "\a" << flush;
#endif
                m_nState = STATE_KICK_BALL;
                m_cSender->InitializeQueue ();
                m_cAdvSkills->Kick (-(best_kick_degree + m_nKickCounter * 10.0), best_power, IGNORE);
                m_nNextLeftDirection = DIRECTION_FRONT;
                m_nNextRightDirection = DIRECTION_FRONT;
                m_nKickCounter++;
                global_best_kick_value = WORST_DISTANCE;
                break;
              case DO_TURN:
#ifdef DEBUG
                cout << "Ich will mich drehen!" << endl;
#endif
                m_nState = STATE_TAKE_WATCH_DIRECTION;
                m_cWeltmodell->neu_entscheiden (SEQUENZ_BEENDET);
                continue;

/*              case DO_GOALKICK:
#ifdef DEBUG
                cout << "Ich will auf das Tor schiessen!" << endl;
#endif
                // fehlt: Bestimmung, ob Torrichtung frei, sonst drehen
                m_nState = STATE_KICK_BALL;
                m_cSender->InitializeQueue ();
                goal_pos = m_cWeltmodell->frage_ihr_tor ().p;
                if (selfPos.x2 >= 0)
                  goal_pos.x2 += GOAL_WIDTH/2.0 - 4.0;
                else
                  goal_pos.x2 -= GOAL_WIDTH/2.0 - 4.0;
                m_cWeltmodell->berechne_relativ (rel_goal_pos, goal_pos);
                m_cAdvSkills->Kick (-(rad_in_deg (rel_goal_pos.richtung) + m_nKickCounter * 5.0), GOAL_KICK_POWER, IGNORE);
                m_nNextLeftDirection = DIRECTION_FRONT;
                m_nNextRightDirection = DIRECTION_FRONT;
                m_nKickCounter++;
                global_best_kick_value = WORST_DISTANCE;
                break; 
*/
              case DO_DRIBBLE:
#ifdef DEBUG
                cout << "Ich will dribbeln!";
#endif
                m_nState = STATE_DRIBBLE_BALL;
                m_cSender->InitializeQueue ();
                m_cAdvSkills->Dribbeln (best_kick_degree);
                m_nNextLeftDirection = DIRECTION_FRONT;
                m_nNextRightDirection = DIRECTION_FRONT;
                global_best_kick_value = WORST_DISTANCE;
                break;
            }
          }
        }
#endif
        break;
      case HALF_TIME:
      case TIME_UP:
      case TIME_UP_WITHOUT_A_TEAM:
      case TIME_OVER:
      case TIME_EXTENDED:
        return;
      case BEFORE_KICK_OFF:
        // das Weltmodell kann fuer die anderen freundlichen Mitspieler
        // die Aufstellungspositionen annehmen
        // entweder mit Zugriffsfkt. oder als Sensorinformation
        if (m_nState == STATE_INIT)
        {
          m_cWeltmodell->setze_stammpos_anstoss (KickoffPositions [m_cWeltmodell->frage_initiative ()] [m_cWeltmodell->frage_nummer ()]);
          m_cWeltmodell->setze_stammpos_spiel ((InplayPositions [m_cWeltmodell->frage_aufstellung ()] [m_cWeltmodell->frage_nummer ()]).position);
	  //m_cWeltmodell->setze_stammpos_ecke (CornerkickPositions [m_cWeltmodell->frage_nummer ()]);
	  //m_cWeltmodell->setze_stammpos_abstoss (GoalkickPositions [m_cWeltmodell->frage_nummer ()]);
          m_cWeltmodell->setze_rolle ((InplayPositions [m_cWeltmodell->frage_aufstellung ()] [m_cWeltmodell->frage_nummer ()]).rolle);
          InitRole ();
          m_cSender->InitializeQueue ();
	  
          m_cAdvSkills->SimpleChangeView (m_cWeltmodell->frage_sicht_breite (), m_cWeltmodell->frage_sicht_qualitaet (), IGNORE);
          m_cAdvSkills->SimpleMoveTo (m_cWeltmodell->frage_stammpos_anstoss ().x1, m_cWeltmodell->frage_stammpos_anstoss ().x2, IGNORE);
          m_cAdvSkills->SimpleChangeView (m_cWeltmodell->frage_sicht_breite (), m_cWeltmodell->frage_sicht_qualitaet (), IGNORE);	  
          m_cAdvSkills->SimpleMoveTo (m_cWeltmodell->frage_stammpos_anstoss ().x1, m_cWeltmodell->frage_stammpos_anstoss ().x2, IGNORE);
        }
        m_nState = STATE_UNKNOWN;
/*        if (m_cWeltmodell->frage_initiative () == INITIATIVE_WIR && m_cWeltmodell->frage_rolle () == ROLLE_RECHTER_STUERMER)
        {
          goal_pos = m_cWeltmodell->frage_unser_tor ().p;
          m_cAdvSkills->SimpleTurn (m_cAdvSkills->ComputeTurnAngle (goal_pos), IGNORE);
        }
        else */
          switch (decideNew ())
          {
            case STATE_LOOK_FOR_BALL:
#ifdef DEBUG
              cout << "Suche den Ball" << endl;
#endif
              m_cAdvSkills->SimpleTurn (80.0, IGNORE);
              break;
            default:
              ballPos = m_cWeltmodell->frage_ball ().frage_p ();
#ifdef DEBUG
              cout << "Ballpos vor dem Anstoss x: " << ballPos.x1 << "  y:" << ballPos.x2 << endl;
#endif
              m_cAdvSkills->SimpleTurn (m_cAdvSkills->ComputeTurnAngle (ballPos), IGNORE);
              break;
          }
        break;
      case GOAL:
        m_cWeltmodell->setze_stammpos_anstoss (KickoffPositions
        [m_cWeltmodell->frage_initiative ()] [m_cWeltmodell->frage_nummer ()]);
	/*if (m_cWeltmodell->frage_aufstellung () == 0)
	  m_cWeltmodell->setze_aufstellung (1);
        else
	  m_cWeltmodell->setze_aufstellung (0);
        m_cWeltmodell->setze_stammpos_spiel ((InplayPositions [m_cWeltmodell->frage_aufstellung ()] [m_cWeltmodell->frage_nummer ()]).position);*/
	m_cSender->InitializeQueue ();
        m_cAdvSkills->SimpleMoveTo (m_cWeltmodell->frage_stammpos_anstoss ().x1, m_cWeltmodell->frage_stammpos_anstoss ().x2, IGNORE);
        m_cAdvSkills->SimpleMoveTo (m_cWeltmodell->frage_stammpos_anstoss ().x1, m_cWeltmodell->frage_stammpos_anstoss ().x2, IGNORE);
/*        if (m_cWeltmodell->frage_initiative () == INITIATIVE_WIR && m_cWeltmodell->frage_rolle () == ROLLE_RECHTER_STUERMER)
        {
          goal_pos = m_cWeltmodell->frage_unser_tor ().p;
          m_cAdvSkills->SimpleTurn (m_cAdvSkills->ComputeTurnAngle (goal_pos), IGNORE);
        }
        else */
          switch (decideNew ())
          {
            case STATE_LOOK_FOR_BALL:
              m_cAdvSkills->SimpleTurn (80.0, IGNORE);
              break;
            default:
              ballPos = m_cWeltmodell->frage_ball ().frage_p ();
              m_cAdvSkills->SimpleTurn (m_cAdvSkills->ComputeTurnAngle (ballPos), IGNORE);
              break;
          }
        m_nNextLeftDirection = DIRECTION_FRONT;
	m_nNextRightDirection = DIRECTION_FRONT;
	m_nKickCounter = 0;
        break;
      case KICK_IN:
      case CORNER_KICK:
      case GOAL_KICK:
      case FREE_KICK:
        ball = m_cWeltmodell->frage_ball ();
        self = m_cWeltmodell->frage_selbst ();
        ballPos = ball.frage_p ();
        selfPos = self.frage_p ();
        
        switch (decideNew ())
        {
          case STATE_LOOK_FOR_BALL:
	  case STATE_SEEK_BALL:  
            m_cSender->InitializeQueue();
            m_cAdvSkills->SimpleTurn (80.0, IGNORE);
            break;
          case STATE_TURN_TO_BALL:
            m_cSender->InitializeQueue();
            m_cAdvSkills->SimpleTurn (m_cAdvSkills->ComputeTurnAngle (ballPos), IGNORE);
            break;
          case STATE_TAKE_INFLUENCE_POS:
          case STATE_TAKE_REGULAR_POS:
            m_cSender->InitializeQueue ();
	    if (m_cWeltmodell->frage_spielzustand () == CORNER_KICK && m_cWeltmodell->frage_initiative () == INITIATIVE_WIR)
	    {
	      // Auf eine besondere Position laufen
	      if (m_cWeltmodell->frage_seite () == linke_seite)
		if (ballPos.x2 > 0)
		  interceptPos = CornerkickPositions [0] [m_cWeltmodell->frage_nummer ()];
		else
		  interceptPos = CornerkickPositions [1] [m_cWeltmodell->frage_nummer ()];
	      else
                if (ballPos.x2 > 0)
		{
		  interceptPos.x1 = -(CornerkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x1;
		  interceptPos.x2 = -(CornerkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x2;
                }
		else
		{
		  interceptPos.x1 = -(CornerkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x1;
		  interceptPos.x2 = -(CornerkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x2;
                }
	      m_cAdvSkills->GotoInterceptPosition (interceptPos);
	    }
	    else
	      if (m_cWeltmodell->frage_spielzustand () == GOAL_KICK && m_cWeltmodell->frage_initiative () == INITIATIVE_SIE)
              {		   
		if (m_cWeltmodell->frage_seite () == linke_seite)
		  if (ballPos.x2 > 0)
		    interceptPos = GoalkickPositions [0] [m_cWeltmodell->frage_nummer ()];
		  else
		    interceptPos = GoalkickPositions [1] [m_cWeltmodell->frage_nummer ()];
                else
		  if (ballPos.x2 > 0)
		  {
		    interceptPos.x1 = -(GoalkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x1;
		    interceptPos.x2 = -(GoalkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x2;
                  }
		  else
		  {
		    interceptPos.x1 = -(GoalkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x1;
		    interceptPos.x2 = -(GoalkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x2;
                  }
		// auf eine besondere Postion laufen
		m_cAdvSkills->GotoInterceptPosition (interceptPos);
              }
	      else
                m_cAdvSkills->GotoInterceptPosition (interceptPos);
            break;
	  case STATE_FETCH_NEAR_BALL:
          case STATE_FETCH_BALL:
            if (m_cWeltmodell->frage_initiative () == INITIATIVE_WIR)
            {
              if (m_nState != STATE_PLACE_NEAR_BALL)
              {
                pos_at_ball = ComputePosBesideBall (ballPos, 4.0, selfPos);
                m_nState = STATE_PLACE_BESIDE_BALL;
              }
              else
                pos_at_ball = ComputePosBesideBall (ballPos, 1.0, selfPos);

            double distanceToPos = (pos_at_ball - selfPos).norm ();
#ifdef DEBUG
              cout << m_nState << endl << endl;
              cout << pos_at_ball.x1 << "       " << pos_at_ball.x2 << endl;
              cout << "distanz " << distanceToPos << endl;
#endif
              if (distanceToPos >= 1.0)
              {
                m_cSender->InitializeQueue ();
                m_cAdvSkills->GotoPosition (pos_at_ball);
              }
              else
              {
                if (m_nState == STATE_PLACE_BESIDE_BALL)
                {
                  m_nState = STATE_PLACE_NEAR_BALL;
                  m_cWeltmodell->neu_entscheiden (SEQUENZ_BEENDET);
                  continue;
                }
                else
                {
                  m_nNextLeftDirection = DIRECTION_FRONT;
                  m_nNextRightDirection = DIRECTION_FRONT;
                  ComputeNextWatchDirection (&next_watch_degree);
#ifdef DEBUG
		  cout << "Bin nah am Ball, Drehwinkel: " << next_watch_degree << endl;
#endif
		  
		  m_cAdvSkills->SimpleTurn (-next_watch_degree);
                  m_cWeltmodell->setze_spielzustand (PLAY_ON);
                  m_nState = STATE_UNKNOWN;
                }
              }
            }
	    else
	    {
	      m_cSender->InitializeQueue ();
	      if (m_cWeltmodell->frage_spielzustand () == CORNER_KICK && m_cWeltmodell->frage_initiative () == INITIATIVE_WIR)
	      {
	        if (m_cWeltmodell->frage_seite () == linke_seite)
	   	  if (ballPos.x2 > 0)
		    interceptPos = CornerkickPositions [0] [m_cWeltmodell->frage_nummer ()];
		  else
		    interceptPos = CornerkickPositions [1] [m_cWeltmodell->frage_nummer ()];
	        else
                  if (ballPos.x2 > 0)
		  {
		    interceptPos.x1 = -(CornerkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x1;
		    interceptPos.x2 = -(CornerkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x2;
                  }
		  else
		  {
		    interceptPos.x1 = -(CornerkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x1;
		    interceptPos.x2 = -(CornerkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x2;
                  }
                m_cAdvSkills->GotoInterceptPosition (interceptPos);
	      } 
	      else
		if (m_cWeltmodell->frage_spielzustand () == GOAL_KICK && m_cWeltmodell->frage_initiative () == INITIATIVE_SIE)
		{
		  if (m_cWeltmodell->frage_seite () == linke_seite)
		    if (ballPos.x2 > 0)
		      interceptPos = GoalkickPositions [0] [m_cWeltmodell->frage_nummer ()];
		    else
		      interceptPos = GoalkickPositions [1] [m_cWeltmodell->frage_nummer ()];
                  else
		    if (ballPos.x2 > 0)
		    {
		      interceptPos.x1 = -(GoalkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x1;
		      interceptPos.x2 = -(GoalkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x2;
                    }
		    else
		    {
		      interceptPos.x1 = -(GoalkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x1;
		      interceptPos.x2 = -(GoalkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x2;
                    }
                  m_cAdvSkills->GotoInterceptPosition (interceptPos);
                }
	  	else
	          m_cAdvSkills->GotoInterceptPosition (m_cWeltmodell->frage_stammpos_spiel ()); 
	    }
	    m_nNextLeftDirection = DIRECTION_FRONT;
	    m_nNextLeftDirection = DIRECTION_FRONT;
	    m_nKickCounter = 0;
	    break;
        }
       break;
      default:
        break;
    }

    m_cWeltmodell->entscheidung_getroffen ();
  }
}
