#include<math.h>

#include"fussbal.h"

// class Vektor

Vektor Vektor::normal(void) const
	{
	register Vektor n; n.x1 = 1; n.x2 = 0;
	
	if(x1 == 0)	return n;
	if(x2 == 0)
		{
		n.x1 = 0; n.x2 = 1;
		return n;
		}
	
	n.x2 = 1 / sqrt((x1 * x1) / (x2 * x2) + 1);
	n.x1 = -x2 * n.x2 / x1;
	
	return n;
	}

void Vektor::drehen(const Winkel phi)
	{
	if(phi == 0) return;
	
	register Koerper dx1,dx2;
	
	dx1 = x1 * cos(phi) - x2 * sin(phi);
	dx2 = x2 * cos(phi) + x1 * sin(phi);
	
	x1 = dx1,x2 = dx2;
	}

void Vektor::drehen_um(const Winkel phi,const Vektor punkt)
	{
	*this -= punkt;
	this->drehen(phi);
	*this += punkt;
	}

void Vektor::skalieren(const Koerper s1,const Koerper s2)
	{
	x1 *= s1, x2 *= s2;
	}

void Vektor::spiegeln_x1(const Koerper s1)
	{
	x1 = 2 * s1 - x1;
	}

void Vektor::spiegeln_x2(const Koerper s2)
	{
	x2 = 2 * s2 - x2;
	}

Winkel Vektor::arg(void) const
	{
	if(ist_ungefaehr(x1,0))
		{
		if(ist_ungefaehr(x2,0)) return 0;
		else if(x2 > 0) return PI / 2;
		else return -PI / 2;
		}
	
	if(ist_ungefaehr(x2,0))
		{
		if(x1 > 0) return 0;
		else if(x1 < 0) return PI;
		}
	
	Winkel alpha = atan(x2 / x1);

	if(x1 > 0) return alpha;
	else
		{
		if(x2 > 0) return PI + alpha;
		else if(x2 < 0) return -PI + alpha;
		}
	}

void Vektor::setzen(Winkel phi,Koerper l)
	{
	x1 = l * cos(phi);
	x2 = l * sin(phi);
	}
